"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.PacmanBase = void 0;

var _react = require("react");

var _styledComponents = _interopRequireWildcard(require("styled-components"));

var _deck = require("./deck/deck");

var _progress = require("./progress");

var _excluded = ["color", "size"];

var _templateObject, _templateObject2, _templateObject3, _templateObject4, _templateObject5, _templateObject6, _templateObject7;

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function _taggedTemplateLiteral(strings, raw) { if (!raw) { raw = strings.slice(0); } return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }

var PacmanBase = _styledComponents.default.div(_templateObject || (_templateObject = _taggedTemplateLiteral(["\n  position: absolute;\n  top: ", "px;\n  left: ", "px;\n  height: ", "px;\n  width: ", "px;\n  transition: left 0.3s ease-in-out 0.2s;\n  transform: translate(-50%, -50%);\n"])), function (_ref) {
  var top = _ref.top;
  return top;
}, function (_ref2) {
  var left = _ref2.left;
  return left;
}, function (_ref3) {
  var pacmanSize = _ref3.pacmanSize;
  return pacmanSize;
}, function (_ref4) {
  var pacmanSize = _ref4.pacmanSize;
  return pacmanSize;
});

exports.PacmanBase = PacmanBase;
var pacmanTopFrames = (0, _styledComponents.keyframes)(_templateObject2 || (_templateObject2 = _taggedTemplateLiteral(["\n  0% { transform: rotateZ(0deg) }\n  100% { transform: rotateZ(-30deg) }\n"])));
var pacmanBottomFrames = (0, _styledComponents.keyframes)(_templateObject3 || (_templateObject3 = _taggedTemplateLiteral(["\n  0% { transform: rotateZ(0deg) }\n  100% { transform: rotateZ(30deg) }\n"]))); // NOTE: rotateZ is 0.1 to generate two different animation names (styled components deduplication)

var pacmanTopFramesAlternate = (0, _styledComponents.keyframes)(_templateObject4 || (_templateObject4 = _taggedTemplateLiteral(["\n  0% { transform: rotateZ(0.1deg) }\n  100% { transform: rotateZ(-30deg) }\n"]))); // NOTE: rotateZ is 0.1 to generate two different animation names (styled components deduplication)

var pacmanBottomFramesAlternate = (0, _styledComponents.keyframes)(_templateObject5 || (_templateObject5 = _taggedTemplateLiteral(["\n  0% { transform: rotateZ(0.1deg) }\n  100% { transform: rotateZ(30deg) }\n"])));

var PacmanBodyTop = _styledComponents.default.div(_templateObject6 || (_templateObject6 = _taggedTemplateLiteral(["\n  position: absolute;\n  top: 0;\n  height: ", "px;\n  width: ", "px;\n  background: ", ";\n  border-top-left-radius: ", "px;\n  border-top-right-radius: ", "px;\n  // NOTE: So the top and bottom always overlap when sizes are in decimals.\n  box-shadow: 0 0 0 0.5px ", ";\n  animation-name: ", ";\n  animation-duration: 0.12s;\n  animation-timing-function: linear;\n  animation-iteration-count: 10;\n  animation-direction: alternate;\n  animation-fill-mode: both;\n"])), function (_ref5) {
  var pacmanSize = _ref5.pacmanSize;
  return pacmanSize / 2;
}, function (_ref6) {
  var pacmanSize = _ref6.pacmanSize;
  return pacmanSize;
}, function (_ref7) {
  var color = _ref7.color;
  return color;
}, function (_ref8) {
  var pacmanSize = _ref8.pacmanSize;
  return pacmanSize / 2;
}, function (_ref9) {
  var pacmanSize = _ref9.pacmanSize;
  return pacmanSize / 2;
}, function (_ref10) {
  var color = _ref10.color;
  return color;
}, function (_ref11) {
  var alternate = _ref11.alternate;
  return alternate ? pacmanTopFrames : pacmanTopFramesAlternate;
});

var PacmanBodyBottom = (0, _styledComponents.default)(PacmanBodyTop)(_templateObject7 || (_templateObject7 = _taggedTemplateLiteral(["\n  top: 50%;\n  border-top-left-radius: 0;\n  border-top-right-radius: 0;\n  border-bottom-left-radius: ", "px;\n  border-bottom-right-radius: ", "px;\n  animation-name: ", ";\n"])), function (_ref12) {
  var pacmanSize = _ref12.pacmanSize;
  return pacmanSize / 2;
}, function (_ref13) {
  var pacmanSize = _ref13.pacmanSize;
  return pacmanSize / 2;
}, function (_ref14) {
  var alternate = _ref14.alternate;
  return alternate ? pacmanBottomFrames : pacmanBottomFramesAlternate;
});
var DEFAULT_ANIMATED_PROGRESS_CIRCLE_SIZE = 7.5;
var AnimatedProgress = /*#__PURE__*/(0, _react.forwardRef)(function (_ref15, ref) {
  var _ref15$color = _ref15.color,
      circleColor = _ref15$color === void 0 ? '#fff' : _ref15$color,
      _ref15$size = _ref15.size,
      circleSize = _ref15$size === void 0 ? DEFAULT_ANIMATED_PROGRESS_CIRCLE_SIZE : _ref15$size,
      props = _objectWithoutProperties(_ref15, _excluded);

  var _useContext = (0, _react.useContext)(_deck.DeckContext),
      slideCount = _useContext.slideCount,
      skipTo = _useContext.skipTo,
      slideIndex = _useContext.activeView.slideIndex;

  var _useState = (0, _react.useState)(null),
      _useState2 = _slicedToArray(_useState, 2),
      pacmanOffsetLeft = _useState2[0],
      setPacmanOffsetLeft = _useState2[1];

  var _useState3 = (0, _react.useState)(null),
      _useState4 = _slicedToArray(_useState3, 2),
      pacmanOffsetTop = _useState4[0],
      setPacmanOffsetTop = _useState4[1];

  var _useState5 = (0, _react.useState)(false),
      _useState6 = _slicedToArray(_useState5, 2),
      alternateAnimation = _useState6[0],
      setAlternateAnimation = _useState6[1];

  var _useState7 = (0, _react.useState)(null),
      _useState8 = _slicedToArray(_useState7, 2),
      activeCircleNode = _useState8[0],
      setActiveCircleNode = _useState8[1];

  var activeCircleCallbackRef = (0, _react.useCallback)(function (activeCircleNode) {
    setActiveCircleNode(activeCircleNode);
  }, []);
  (0, _react.useEffect)(function () {
    if (activeCircleNode !== null && activeCircleNode !== void 0 && activeCircleNode.offsetParent) {
      var offsetLeft = activeCircleNode.offsetLeft,
          offsetTop = activeCircleNode.offsetTop;
      var halfOfCircleOccupiedSpace = circleSize / 2 + _progress.PROGRESS_CIRCLE_BORDER_WIDTH;
      setPacmanOffsetLeft(offsetLeft + halfOfCircleOccupiedSpace);
      setPacmanOffsetTop(offsetTop + halfOfCircleOccupiedSpace);
      setAlternateAnimation(function (alternateAnimation) {
        return !alternateAnimation;
      });
    } else {
      setPacmanOffsetLeft(null);
      setPacmanOffsetTop(null);
    }
  }, [circleSize, activeCircleNode]);
  var circleMargin = (_progress.DEFAULT_PROGRESS_CIRCLE_WIDTH_INCLUDING_MARGIN - DEFAULT_ANIMATED_PROGRESS_CIRCLE_SIZE - _progress.PROGRESS_CIRCLE_BORDER_WIDTH * 2) / 2;
  var pacmanColor = props.pacmanColor || circleColor;
  var pacmanSize = circleSize + _progress.PROGRESS_CIRCLE_BORDER_WIDTH + circleMargin * 2;
  return /*#__PURE__*/React.createElement(_progress.ProgressContainer, _extends({
    ref: ref,
    position: "relative"
  }, props), typeof pacmanOffsetTop === 'number' && typeof pacmanOffsetLeft === 'number' && /*#__PURE__*/React.createElement(PacmanBase, {
    pacmanSize: pacmanSize,
    top: pacmanOffsetTop,
    left: pacmanOffsetLeft
  }, /*#__PURE__*/React.createElement(PacmanBodyTop, {
    color: pacmanColor,
    pacmanSize: pacmanSize,
    alternate: alternateAnimation
  }), /*#__PURE__*/React.createElement(PacmanBodyBottom, {
    color: pacmanColor,
    pacmanSize: pacmanSize,
    alternate: alternateAnimation
  })), Array(slideCount).fill(0).map(function (_, idx) {
    return /*#__PURE__*/React.createElement(_progress.Circle, {
      key: idx,
      ref: slideIndex === idx ? activeCircleCallbackRef : null,
      color: circleColor,
      active: false,
      size: circleSize,
      margin: circleMargin,
      onClick: function onClick() {
        return skipTo({
          slideIndex: idx,
          stepIndex: 0
        });
      },
      "data-testid": "animated-progress-circle"
    });
  }));
});
AnimatedProgress.displayName = 'AnimatedProgress';
var _default = AnimatedProgress;
exports.default = _default;