"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _styledComponents = _interopRequireDefault(require("styled-components"));

var _kbar = require("kbar");

var _platformKeys = require("../../../utils/platform-keys");

var _constants = require("../../../utils/constants");

var _typography = require("../../typography");

var _templateObject, _templateObject2, _templateObject3, _templateObject4;

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _taggedTemplateLiteral(strings, raw) { if (!raw) { raw = strings.slice(0); } return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }

function getShortcutKeys(_ref) {
  var id = _ref.id,
      _ref$shortcut = _ref.shortcut,
      shortcut = _ref$shortcut === void 0 ? [] : _ref$shortcut;

  if (id in _constants.KEYBOARD_SHORTCUTS && !(shortcut !== null && shortcut !== void 0 && shortcut.length)) {
    var _id = id;
    return (0, _platformKeys.prettifyShortcut)(_constants.KEYBOARD_SHORTCUTS[_id]);
  }

  return (0, _platformKeys.prettifyShortcut)(shortcut);
}

var ResultCommand = _styledComponents.default.div(_templateObject || (_templateObject = _taggedTemplateLiteral(["\n  display: flex;\n  justify-content: space-between;\n  align-items: center;\n  background-color: ", ";\n  padding: 0.5rem 1rem;\n  cursor: pointer;\n  height: 30px;\n"])), function (p) {
  return p.active ? 'lightsteelblue' : 'transparent';
});

var ResultSectionHeader = (0, _styledComponents.default)(_typography.Text)(_templateObject2 || (_templateObject2 = _taggedTemplateLiteral(["\n  background-color: white;\n  color: gray;\n  margin: 0 2rem;\n  padding: 0.5rem 0;\n  font-size: small;\n  font-weight: bold;\n  font-family: ", ";\n"])), _constants.SYSTEM_FONT);

var ResultShortcut = _styledComponents.default.span(_templateObject3 || (_templateObject3 = _taggedTemplateLiteral(["\n  display: flex;\n  gap: 5px;\n"])));

var ResultShortcutKey = _styledComponents.default.kbd(_templateObject4 || (_templateObject4 = _taggedTemplateLiteral(["\n  display: flex;\n  justify-content: center;\n  align-items: center;\n  background-color: #eee;\n  border-radius: 5px;\n  border: 1px solid #b4b4b4;\n  padding: 5px 10px;\n  min-width: 20px;\n  height: 25px;\n  white-space: nowrap;\n  font-family: ", ";\n"])), _constants.SYSTEM_FONT);

function onRender(_ref2) {
  var item = _ref2.item,
      active = _ref2.active;

  if (typeof item === 'string') {
    return /*#__PURE__*/React.createElement(ResultSectionHeader, null, item);
  } else {
    return /*#__PURE__*/React.createElement(ResultCommand, {
      active: active
    }, /*#__PURE__*/React.createElement(_typography.Text, {
      fontFamily: _constants.SYSTEM_FONT
    }, item.name), /*#__PURE__*/React.createElement(ResultShortcut, null, getShortcutKeys(item).map(function (key) {
      return key && /*#__PURE__*/React.createElement(ResultShortcutKey, {
        key: "".concat(item.id, "-").concat(key)
      }, key);
    })));
  }
}

var CommandBarResults = function CommandBarResults() {
  var _useMatches = (0, _kbar.useMatches)(),
      results = _useMatches.results;

  return /*#__PURE__*/React.createElement(_kbar.KBarResults, {
    items: results,
    onRender: onRender
  });
};

var _default = CommandBarResults;
exports.default = _default;