"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = require("react");

var _defaultDeck = _interopRequireDefault(require("./default-deck"));

var _presenterMode = _interopRequireDefault(require("../presenter-mode"));

var _printMode = _interopRequireDefault(require("../print-mode"));

var _useMousetrap2 = _interopRequireDefault(require("../../hooks/use-mousetrap"));

var _constants = require("../../utils/constants");

var _useModes2 = _interopRequireDefault(require("../../hooks/use-modes"));

var _commandBar = _interopRequireDefault(require("../command-bar"));

var _excluded = ["getCurrentMode", "toggleMode"];

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var View = function View(_ref) {
  var getCurrentMode = _ref.getCurrentMode,
      toggleMode = _ref.toggleMode,
      props = _objectWithoutProperties(_ref, _excluded);

  var mode = getCurrentMode();

  switch (mode) {
    case _constants.SPECTACLE_MODES.DEFAULT_MODE:
      return /*#__PURE__*/React.createElement(_defaultDeck.default, _extends({}, props, {
        toggleMode: toggleMode
      }));

    case _constants.SPECTACLE_MODES.PRESENTER_MODE:
      return /*#__PURE__*/React.createElement(_presenterMode.default, props);

    /**
     * Print mode and export mode are identical except for the theme
     * that is used. Print mode uses the print theme which is usually
     * monotone and export mode uses the default theme.
     */

    case _constants.SPECTACLE_MODES.PRINT_MODE:
      return /*#__PURE__*/React.createElement(_printMode.default, props);

    case _constants.SPECTACLE_MODES.EXPORT_MODE:
      return /*#__PURE__*/React.createElement(_printMode.default, _extends({}, props, {
        exportMode: true
      }));

    case _constants.SPECTACLE_MODES.OVERVIEW_MODE:
      return /*#__PURE__*/React.createElement(_defaultDeck.default, _extends({
        overviewMode: true,
        toggleMode: toggleMode
      }, props));

    default:
      return /*#__PURE__*/React.createElement(_react.Fragment, null);
  }
};

var SpectacleDeck = function SpectacleDeck(props) {
  var _useMousetrap;

  var _useModes = (0, _useModes2.default)(),
      toggleMode = _useModes.toggleMode,
      getCurrentMode = _useModes.getCurrentMode;

  (0, _useMousetrap2.default)((_useMousetrap = {}, _defineProperty(_useMousetrap, _constants.KEYBOARD_SHORTCUTS.PRESENTER_MODE, function (e) {
    return e && toggleMode({
      e: e,
      newMode: _constants.SPECTACLE_MODES.PRESENTER_MODE
    });
  }), _defineProperty(_useMousetrap, _constants.KEYBOARD_SHORTCUTS.PRINT_MODE, function (e) {
    return e && toggleMode({
      e: e,
      newMode: _constants.SPECTACLE_MODES.PRINT_MODE
    });
  }), _defineProperty(_useMousetrap, _constants.KEYBOARD_SHORTCUTS.EXPORT_MODE, function (e) {
    return e && toggleMode({
      e: e,
      newMode: _constants.SPECTACLE_MODES.EXPORT_MODE
    });
  }), _defineProperty(_useMousetrap, _constants.KEYBOARD_SHORTCUTS.OVERVIEW_MODE, function (e) {
    return e && toggleMode({
      e: e,
      newMode: _constants.SPECTACLE_MODES.OVERVIEW_MODE
    });
  }), _useMousetrap), []);
  return /*#__PURE__*/React.createElement(_commandBar.default, null, /*#__PURE__*/React.createElement(View, _extends({
    getCurrentMode: getCurrentMode,
    toggleMode: toggleMode
  }, props)));
};

var _default = SpectacleDeck;
exports.default = _default;