"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var React = _interopRequireWildcard(require("react"));

var _styledComponents = _interopRequireDefault(require("styled-components"));

var _slide = _interopRequireDefault(require("./slide/slide"));

var _layoutPrimitives = require("./layout-primitives");

var _codePane = _interopRequireDefault(require("./code-pane"));

var _typography = require("./typography");

var _appear = require("./appear");

var _templateObject, _templateObject2;

var _excluded = ["children"],
    _excluded2 = ["children"],
    _excluded3 = ["left", "right"],
    _excluded4 = ["title", "items", "listType", "animateListItems", "titleProps", "listProps"],
    _excluded5 = ["flexBoxProps", "headingProps", "children"],
    _excluded6 = ["children", "factInformation", "factProps", "factFontSize", "factInformationProps"],
    _excluded7 = ["children", "quoteProps", "attribution", "attributionProps"],
    _excluded8 = ["text", "textProps", "children"],
    _excluded9 = ["children", "language", "title", "titleProps", "codePaneProps"],
    _excluded10 = ["codeBlocks", "title", "titleProps", "numColumns"],
    _excluded11 = ["description", "descriptionProps", "code"],
    _excluded12 = ["src", "alt", "title", "titleProps", "description", "descriptionProps", "imgProps", "imgContainerProps", "objectFit"],
    _excluded13 = ["src", "alt", "title", "titleProps", "listType", "listItems", "animateListItems", "listProps", "imgProps", "imgContainerProps", "position", "objectFit"],
    _excluded14 = ["primary", "top", "bottom"],
    _excluded15 = ["src", "alt", "imgProps", "imgContainerProps", "objectFit"];

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _taggedTemplateLiteral(strings, raw) { if (!raw) { raw = strings.slice(0); } return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }

function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

/**
 * Full-slide layout
 */
var Full = function Full(_ref) {
  var children = _ref.children,
      rest = _objectWithoutProperties(_ref, _excluded);

  return /*#__PURE__*/React.createElement(_slide.default, rest, children);
};
/**
 * Centered layout
 */


var Center = function Center(_ref2) {
  var children = _ref2.children,
      rest = _objectWithoutProperties(_ref2, _excluded2);

  return /*#__PURE__*/React.createElement(_slide.default, rest, /*#__PURE__*/React.createElement(_layoutPrimitives.FlexBox, {
    justifyContent: "center",
    alignItems: "center",
    height: "100%"
  }, /*#__PURE__*/React.createElement(_layoutPrimitives.Box, null, children)));
};
/**
 * Two-column layout
 */


var TwoColumn = function TwoColumn(_ref3) {
  var left = _ref3.left,
      right = _ref3.right,
      rest = _objectWithoutProperties(_ref3, _excluded3);

  return /*#__PURE__*/React.createElement(_slide.default, rest, /*#__PURE__*/React.createElement(_layoutPrimitives.FlexBox, {
    flexDirection: "row",
    alignItems: "start",
    flex: 1
  }, /*#__PURE__*/React.createElement(_layoutPrimitives.Box, {
    width: "100%"
  }, left), /*#__PURE__*/React.createElement(_layoutPrimitives.Box, {
    width: "100%"
  }, right)));
};
/**
 * Generic List utility
 */


var Ul = function Ul(_ref4) {
  var _ref4$items = _ref4.items,
      items = _ref4$items === void 0 ? [] : _ref4$items,
      _ref4$type = _ref4.type,
      type = _ref4$type === void 0 ? 'unordered' : _ref4$type,
      _ref4$animate = _ref4.animate,
      animate = _ref4$animate === void 0 ? false : _ref4$animate,
      listProps = _ref4.listProps;
  var List = type === 'unordered' ? _typography.UnorderedList : _typography.OrderedList;
  return /*#__PURE__*/React.createElement(List, listProps, items.map(function (item, i) {
    var Wrapper = animate ? _appear.Appear : React.Fragment;
    return /*#__PURE__*/React.createElement(Wrapper, {
      key: i
    }, /*#__PURE__*/React.createElement(_typography.ListItem, {
      key: i
    }, item));
  }));
};
/**
 * List layout with optional title
 */


var List = function List(_ref5) {
  var title = _ref5.title,
      items = _ref5.items,
      _ref5$listType = _ref5.listType,
      listType = _ref5$listType === void 0 ? 'unordered' : _ref5$listType,
      _ref5$animateListItem = _ref5.animateListItems,
      animateListItems = _ref5$animateListItem === void 0 ? false : _ref5$animateListItem,
      titleProps = _ref5.titleProps,
      listProps = _ref5.listProps,
      rest = _objectWithoutProperties(_ref5, _excluded4);

  return /*#__PURE__*/React.createElement(_slide.default, rest, title ? /*#__PURE__*/React.createElement(_typography.Heading, _extends({
    textAlign: "left"
  }, titleProps), title) : null, /*#__PURE__*/React.createElement(Ul, {
    items: items,
    animate: animateListItems,
    type: listType,
    listProps: listProps
  }));
};
/**
 * Generic vertically-centered Header layout
 */


var Header = function Header(_ref6) {
  var flexBoxProps = _ref6.flexBoxProps,
      headingProps = _ref6.headingProps,
      children = _ref6.children,
      rest = _objectWithoutProperties(_ref6, _excluded5);

  return /*#__PURE__*/React.createElement(_slide.default, rest, /*#__PURE__*/React.createElement(_layoutPrimitives.FlexBox, _extends({
    height: "100%"
  }, flexBoxProps), /*#__PURE__*/React.createElement(_typography.Heading, headingProps, children)));
};
/**
 * Section layout with left aligned text
 */


var Section = function Section(_ref7) {
  var sectionProps = _ref7.sectionProps,
      children = _ref7.children;
  return /*#__PURE__*/React.createElement(Header, {
    headingProps: sectionProps,
    flexBoxProps: {
      justifyContent: 'flex-start'
    }
  }, children);
};
/**
 * Statement layout with centered text
 */


var Statement = function Statement(_ref8) {
  var statementProps = _ref8.statementProps,
      children = _ref8.children;
  return /*#__PURE__*/React.createElement(Header, {
    headingProps: statementProps
  }, children);
};
/**
 * Big Fact with optional fact information
 */


var BigFact = function BigFact(_ref9) {
  var children = _ref9.children,
      factInformation = _ref9.factInformation,
      factProps = _ref9.factProps,
      _ref9$factFontSize = _ref9.factFontSize,
      factFontSize = _ref9$factFontSize === void 0 ? '250px' : _ref9$factFontSize,
      factInformationProps = _ref9.factInformationProps,
      rest = _objectWithoutProperties(_ref9, _excluded6);

  return /*#__PURE__*/React.createElement(_slide.default, rest, /*#__PURE__*/React.createElement(_layoutPrimitives.FlexBox, null, /*#__PURE__*/React.createElement(_layoutPrimitives.Box, null, /*#__PURE__*/React.createElement(_typography.Text, _extends({
    textAlign: "center",
    fontSize: factFontSize
  }, factProps), children), factInformation ? /*#__PURE__*/React.createElement(_typography.Text, _extends({
    textAlign: "center"
  }, factInformationProps), factInformation) : null)));
};
/**
 * Quote layout
 */


var Quote = function Quote(_ref10) {
  var children = _ref10.children,
      quoteProps = _ref10.quoteProps,
      attribution = _ref10.attribution,
      attributionProps = _ref10.attributionProps,
      rest = _objectWithoutProperties(_ref10, _excluded7);

  return /*#__PURE__*/React.createElement(_slide.default, rest, /*#__PURE__*/React.createElement(_layoutPrimitives.Box, {
    width: "100%",
    margin: "auto"
  }, /*#__PURE__*/React.createElement(_typography.Text, _extends({
    fontSize: "85px"
  }, quoteProps), children), /*#__PURE__*/React.createElement(_typography.Text, _extends({
    fontSize: "36px",
    padding: '0em 0em 0em 1em'
  }, attributionProps), "\u2013", attribution)));
};
/**
 * Generic Codepane utility with optional Description text
 */


var CodeLayout = function CodeLayout(_ref11) {
  var text = _ref11.text,
      textProps = _ref11.textProps,
      children = _ref11.children,
      props = _objectWithoutProperties(_ref11, _excluded8);

  return /*#__PURE__*/React.createElement(_layoutPrimitives.Box, {
    "data-testid": "CodePane"
  }, text ? /*#__PURE__*/React.createElement(_typography.Text, _extends({
    margin: 8
  }, textProps), text) : null, /*#__PURE__*/React.createElement(_codePane.default, props, children));
};
/**
 * single Code Pane with optional Title layout
 */


var Code = function Code(_ref12) {
  var children = _ref12.children,
      language = _ref12.language,
      title = _ref12.title,
      titleProps = _ref12.titleProps,
      codePaneProps = _ref12.codePaneProps,
      rest = _objectWithoutProperties(_ref12, _excluded9);

  return /*#__PURE__*/React.createElement(_slide.default, rest, /*#__PURE__*/React.createElement(_layoutPrimitives.Box, {
    display: "inline-block",
    style: {
      overflow: 'scroll'
    }
  }, title ? /*#__PURE__*/React.createElement(_typography.Heading, titleProps, title) : null, /*#__PURE__*/React.createElement(CodeLayout, _extends({
    language: language
  }, codePaneProps), children)));
};
/**
 * multiple Code Panes with optional Description, with optional Title layout
 */


var MultiCodeLayout = function MultiCodeLayout(_ref13) {
  var codeBlocks = _ref13.codeBlocks,
      title = _ref13.title,
      titleProps = _ref13.titleProps,
      _ref13$numColumns = _ref13.numColumns,
      numColumns = _ref13$numColumns === void 0 ? 1 : _ref13$numColumns,
      rest = _objectWithoutProperties(_ref13, _excluded10);

  return /*#__PURE__*/React.createElement(_slide.default, rest, /*#__PURE__*/React.createElement(_layoutPrimitives.Box, {
    display: "inline-block",
    style: {
      overflow: 'scroll'
    }
  }, title ? /*#__PURE__*/React.createElement(_typography.Heading, titleProps, title) : null, /*#__PURE__*/React.createElement(_layoutPrimitives.Grid, {
    gridRowGap: 1,
    gridColumnGap: 1,
    gridTemplateColumns: "repeat(".concat(numColumns, ", minmax(100px, 1fr))"),
    maxWidth: "100%"
  }, codeBlocks.map(function (_ref14, i) {
    var description = _ref14.description,
        descriptionProps = _ref14.descriptionProps,
        code = _ref14.code,
        codePaneProps = _objectWithoutProperties(_ref14, _excluded11);

    return /*#__PURE__*/React.createElement(CodeLayout, _extends({
      key: i,
      text: description,
      textProps: descriptionProps
    }, codePaneProps), code);
  }))));
};
/**
 * Generic styled-component Image utilities
 */


var Img = _styledComponents.default.img(_templateObject || (_templateObject = _taggedTemplateLiteral(["\n  min-width: 100%;\n  min-height: 100%;\n  max-width: 100%;\n  object-fit: ", ";\n"])), function (props) {
  return props.objectFit || 'contain';
});

var ImgContainer = (0, _styledComponents.default)(_layoutPrimitives.FlexBox)(_templateObject2 || (_templateObject2 = _taggedTemplateLiteral(["\n  overflow: hidden;\n"])));

var Image = function Image(_ref15) {
  var src = _ref15.src,
      _ref15$alt = _ref15.alt,
      alt = _ref15$alt === void 0 ? '' : _ref15$alt,
      imgContainerProps = _ref15.imgContainerProps,
      imgProps = _ref15.imgProps,
      objectFit = _ref15.objectFit;
  return /*#__PURE__*/React.createElement(ImgContainer, _extends({
    "data-testid": "ImgContainer"
  }, imgContainerProps), /*#__PURE__*/React.createElement(Img, _extends({
    "data-testid": "Img",
    src: src,
    alt: alt,
    objectFit: objectFit
  }, imgProps)));
};
/**
 * Horizontal Image layout with optional Title and Description
 */


var HorizontalImage = function HorizontalImage(_ref16) {
  var src = _ref16.src,
      alt = _ref16.alt,
      title = _ref16.title,
      titleProps = _ref16.titleProps,
      description = _ref16.description,
      descriptionProps = _ref16.descriptionProps,
      imgProps = _ref16.imgProps,
      imgContainerProps = _ref16.imgContainerProps,
      objectFit = _ref16.objectFit,
      rest = _objectWithoutProperties(_ref16, _excluded12);

  return /*#__PURE__*/React.createElement(_slide.default, rest, /*#__PURE__*/React.createElement(Image, {
    src: src,
    alt: alt,
    objectFit: objectFit,
    imgContainerProps: _objectSpread({
      width: '100%'
    }, imgContainerProps),
    imgProps: imgProps
  }), title ? /*#__PURE__*/React.createElement(_typography.Heading, _extends({
    textAlign: "left",
    margin: "0 0"
  }, titleProps), title) : null, description ? /*#__PURE__*/React.createElement(_typography.Text, _extends({
    margin: "0 0"
  }, descriptionProps), description) : null);
};
/**
 * Image and List layout with optional Title
 */


var VerticalImage = function VerticalImage(_ref17) {
  var src = _ref17.src,
      alt = _ref17.alt,
      title = _ref17.title,
      titleProps = _ref17.titleProps,
      _ref17$listType = _ref17.listType,
      listType = _ref17$listType === void 0 ? 'unordered' : _ref17$listType,
      listItems = _ref17.listItems,
      _ref17$animateListIte = _ref17.animateListItems,
      animateListItems = _ref17$animateListIte === void 0 ? false : _ref17$animateListIte,
      listProps = _ref17.listProps,
      imgProps = _ref17.imgProps,
      imgContainerProps = _ref17.imgContainerProps,
      _ref17$position = _ref17.position,
      position = _ref17$position === void 0 ? 'left' : _ref17$position,
      objectFit = _ref17.objectFit,
      rest = _objectWithoutProperties(_ref17, _excluded13);

  return /*#__PURE__*/React.createElement(_slide.default, rest, title ? /*#__PURE__*/React.createElement(_typography.Heading, titleProps, title) : null, /*#__PURE__*/React.createElement(_layoutPrimitives.Grid, {
    gridColumnGap: 2,
    gridTemplateColumns: 'repeat(2, 1fr)',
    height: '100%'
  }, /*#__PURE__*/React.createElement(_layoutPrimitives.FlexBox, {
    justifyContent: "start"
  }, /*#__PURE__*/React.createElement(Ul, _extends({
    items: listItems,
    animate: animateListItems,
    type: listType
  }, listProps))), /*#__PURE__*/React.createElement(Image, {
    src: src,
    alt: alt,
    objectFit: objectFit,
    imgContainerProps: _objectSpread({
      order: position === 'right' ? 1 : -1
    }, imgContainerProps),
    imgProps: imgProps
  })));
};
/**
 * Image 3-up layout
 */


var ThreeUpImage = function ThreeUpImage(_ref18) {
  var primary = _ref18.primary,
      top = _ref18.top,
      bottom = _ref18.bottom,
      rest = _objectWithoutProperties(_ref18, _excluded14);

  return /*#__PURE__*/React.createElement(_slide.default, rest, /*#__PURE__*/React.createElement(_layoutPrimitives.Grid, {
    height: '100%',
    gridColumnGap: 2,
    gridTemplateColumns: 'repeat(2, 1fr)'
  }, /*#__PURE__*/React.createElement(_layoutPrimitives.Grid, {
    gridRowGap: 2,
    gridTemplateRows: 'repeat(2, .5fr)'
  }, /*#__PURE__*/React.createElement(Image, {
    src: top.src,
    alt: top.alt,
    objectFit: top.objectFit,
    imgProps: top.imgProps,
    imgContainerProps: _objectSpread({}, top.imgContainerProps)
  }), /*#__PURE__*/React.createElement(Image, {
    src: bottom.src,
    alt: bottom.alt,
    objectFit: bottom.objectFit,
    imgProps: bottom.imgProps,
    imgContainerProps: _objectSpread({}, bottom.imgContainerProps)
  })), /*#__PURE__*/React.createElement(Image, {
    src: primary.src,
    alt: primary.alt,
    objectFit: primary.objectFit,
    imgProps: primary.imgProps,
    imgContainerProps: _objectSpread({
      order: primary.position === 'right' ? 1 : -1
    }, primary.imgContainerProps)
  })));
};
/**
 * Full Bleed Image layout
 */


var FullBleedImage = function FullBleedImage(_ref19) {
  var src = _ref19.src,
      alt = _ref19.alt,
      imgProps = _ref19.imgProps,
      imgContainerProps = _ref19.imgContainerProps,
      objectFit = _ref19.objectFit,
      rest = _objectWithoutProperties(_ref19, _excluded15);

  return /*#__PURE__*/React.createElement(_slide.default, _extends({
    padding: "0 0 0"
  }, rest), /*#__PURE__*/React.createElement(Image, {
    src: src,
    alt: alt,
    objectFit: objectFit || 'cover',
    imgProps: imgProps,
    imgContainerProps: _objectSpread({
      height: '100%'
    }, imgContainerProps)
  }));
};
/**
 * Layouts to consider:
 * - Intro
 */


var _default = {
  Full: Full,
  Center: Center,
  TwoColumn: TwoColumn,
  List: List,
  Section: Section,
  BigFact: BigFact,
  Quote: Quote,
  Statement: Statement,
  Code: Code,
  MultiCodeLayout: MultiCodeLayout,
  HorizontalImage: HorizontalImage,
  VerticalImage: VerticalImage,
  ThreeUpImage: ThreeUpImage,
  FullBleedImage: FullBleedImage
};
exports.default = _default;