"use strict";

/**
 * JSDom does not provide this method, but it's needed for various components
 * to mount appropriately.
 * Here, we're mocking this method with some static values.
 */
window.HTMLElement.prototype.getClientRects = function () {
  return [{
    width: 500,
    height: 300
  }];
};

jest.mock('use-resize-observer', function () {
  return jest.requireActual('use-resize-observer/polyfilled');
});
jest.mock('broadcast-channel', function () {
  var bcExport = jest.requireActual('broadcast-channel');
  var ActualBroadcastChannel = bcExport.BroadcastChannel; // Wrap the BroadcastChannel constructor so it always uses the `simulate`
  // mode. This prevents tests from hanging after mounting a Deck.

  bcExport.BroadcastChannel = function (name) {
    return new ActualBroadcastChannel(name, {
      type: 'simulate'
    });
  };

  return bcExport;
});