export declare const DEFAULT_SLIDE_ELEMENT_INDEX = -1;
export declare const DEFAULT_SLIDE_INDEX = 0;
export declare const SYSTEM_FONT = "-apple-system, BlinkMacSystemFont, \"Segoe UI\", \"Roboto\", \"Helvetica Neue\", Helvetica, sans-serif";
export declare const KEYBOARD_SHORTCUTS: {
    PRESENTER_MODE: string;
    OVERVIEW_MODE: string;
    PRINT_MODE: string;
    EXPORT_MODE: string;
    TAB_FORWARD_OVERVIEW_MODE: string;
    TAB_BACKWARD_OVERVIEW_MODE: string;
    SELECT_SLIDE_OVERVIEW_MODE: string;
    NEXT_SLIDE: string;
    PREVIOUS_SLIDE: string;
};
export declare type KeyboardShortcutTypes = keyof typeof KEYBOARD_SHORTCUTS;
export declare const KEYBOARD_SHORTCUTS_IDS: {
    PRESENTER_MODE: string;
    OVERVIEW_MODE: string;
    PRINT_MODE: string;
    EXPORT_MODE: string;
    TAB_FORWARD_OVERVIEW_MODE: string;
    TAB_BACKWARD_OVERVIEW_MODE: string;
    SELECT_SLIDE_OVERVIEW_MODE: string;
    NEXT_SLIDE: string;
    PREVIOUS_SLIDE: string;
};
export declare const SPECTACLE_MODES: {
    readonly DEFAULT_MODE: "DEFAULT_MODE";
    readonly PRESENTER_MODE: "PRESENTER_MODE";
    readonly OVERVIEW_MODE: "OVERVIEW_MODE";
    readonly PRINT_MODE: "PRINT_MODE";
    readonly EXPORT_MODE: "EXPORT_MODE";
};
declare type ValuesOf<T> = T[keyof T];
export declare type SpectacleMode = ValuesOf<typeof SPECTACLE_MODES>;
export declare type ModeSearchParams = {
    presenterMode?: boolean;
    overviewMode?: boolean;
    printMode?: boolean;
    exportMode?: boolean;
};
export declare type ToggleModeParams = {
    newMode: SpectacleMode;
    senderSlideIndex?: number;
    e?: Event;
};
export {};
//# sourceMappingURL=constants.d.ts.map