"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.useAutoPlay = void 0;

var _react = require("react");

var useAutoPlay = function useAutoPlay(_ref) {
  var _ref$enabled = _ref.enabled,
      enabled = _ref$enabled === void 0 ? false : _ref$enabled,
      _ref$loop = _ref.loop,
      loop = _ref$loop === void 0 ? false : _ref$loop,
      stepForward = _ref.stepForward,
      _ref$interval = _ref.interval,
      interval = _ref$interval === void 0 ? 1000 : _ref$interval;
  var stepFn = (0, _react.useRef)(stepForward);
  stepFn.current = stepForward;
  (0, _react.useEffect)(function () {
    if (enabled) {
      var id = setInterval(function () {
        stepFn.current();
      }, interval);
      return function () {
        return clearInterval(id);
      };
    }
  }, [enabled, interval, loop]);
};

exports.useAutoPlay = useAutoPlay;